USE ReportServer
go
ALTER TRIGGER StoreVersion ON dbo.Catalog
   FOR INSERT, UPDATE
AS
   BEGIN
      INSERT INTO ReportServer.dbo.VersionStore
            ( ItemId
            ,Name
            ,ModifiedDate
            ,ModifiedBy
            ,InsertedDate
            ,Def
            )
            SELECT ItemId
                 ,[Name]
                 ,ModifiedDate
                 ,u.UserName ModifiedBy
                 ,GETDATE() InsertedDate
                 ,CONVERT(XML, CONVERT(VARCHAR(MAX), CONVERT(VARBINARY(MAX), CONTENT))) Def
               FROM Catalog C 
                  INNER JOIN Users U
                  ON u.UserID = c.ModifiedByID
               WHERE Content IS NOT NULL AND Type != 3
                  AND ItemID IN (
                  SELECT c.ItemID
                     FROM Catalog C 
                        LEFT OUTER JOIN ( SELECT v1.ItemID
                                               ,MAX(v1.modifiedDate) modifiedDate
                                             FROM VersionStore V1
                                             GROUP BY ItemID
                                        ) V
                        ON C.ItemID = v.ItemID
                     WHERE Content IS NOT NULL
                        AND ( v.itemID IS NULL
                              OR v.modifiedDate != c.ModifiedDate
                            ) )
   END 